import bpy
from bpy.types import Menu, Operator, Panel

bl_info = {
    "name": "BagaPie Modifier",
    "author": "Antoine Bagattini",
    "version": (0, 2, 0, 2),
    "description": "Create a pie menu to add some modifier and Geometry Nodes preset.",
    "blender": (2, 93, 0),
    "cathegory": "3D view",
    "location": "Pie Menue, shortcut : J"
}

# _______________________________________________ HELLO !

# This addon is free, you can use it for any purpose, modify it and share it.

# Thanks to Sybren A. Stüvel (Scripting for artist on Blender Cloud), Drarkfall (Youtube) and Franck Demongin.
# Also thanks to all the people who support the development of this addon.

# If you have any idea/advice to improve this addon, do not hesitate to contact me !
# I'm not a programmer. I'm a Python beginner. This code sucks but it works !

# _______________________________________________ USER INTERFACE / OP PANEL AND N PANEL

class BAGAPIE_MT_PIE_template(Menu):
    bl_label = "BagaPie"
    bl_idname = "mesh.bagapie"

    def draw(self, context):
        layout = self.layout

        pie = layout.menu_pie()
        pie.operator("wm.array")
        pie.operator("wm.boolean")
        pie.operator("wm.wall")
        pie.operator("wm.scatter")
        pie.operator("wm.scatter_paint")
        pie.operator("wm.displace")
        pie.operator("wm.window")
        pie.operator("wm.curvearray")


class BAGAPANEL_PT_modifier_panel(Panel):
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = "BagaPie"
    bl_label = "BagaPie Modifier"

    def draw(self, context):
        layout = self.layout
        scene = context.scene
        col = layout.column()
        row = layout.row()
        box = layout.box()

        convert_to_list = list(context.scene.bagapieValue.split(" "))
        operator_type = convert_to_list[0]

        if operator_type == "ARRAY":
            obj_target = bpy.data.objects[convert_to_list[1]]

            col.label(text=("Array :" + obj_target.name))

            if convert_to_list[2] == 'LINE':
                array_modifier = obj_target.modifiers[convert_to_list[3]]
                col.prop(array_modifier, '["Input_5"]', text = "Count")
                col.prop(array_modifier, '["Input_7"]', text = "Offset")
                col.prop(array_modifier, '["Input_9"]', text = "Random Position")
                col.prop(array_modifier, '["Input_11"]', text = "Random Rotation")
                col.prop(array_modifier, '["Input_13"]', text = "Min Scale")
                col.prop(array_modifier, '["Input_15"]', text = "Max Scale")
                col.prop(array_modifier, '["Input_17"]', text = "Seed")

            if convert_to_list[2] == 'GRID':
                array_modifier = obj_target.modifiers[convert_to_list[3]]
                col.prop(array_modifier, '["Input_5"]', text = "Offset X")
                col.prop(array_modifier, '["Input_7"]', text = "Count X")
                col.prop(array_modifier, '["Input_9"]', text = "Offset Y")
                col.prop(array_modifier, '["Input_11"]', text = "Count Y")
                col.prop(array_modifier, '["Input_13"]', text = "Random Position")
                col.prop(array_modifier, '["Input_15"]', text = "Random Rotation")
                col.prop(array_modifier, '["Input_17"]', text = "Min Scale")
                col.prop(array_modifier, '["Input_19"]', text = "Max Scale")
                col.prop(array_modifier, '["Input_21"]', text = "Seed")

            if convert_to_list[2] == 'CIRCLE':
                array_modifier = obj_target.modifiers[convert_to_list[3]]
                col.prop(array_modifier, '["Input_5"]', text = "Count")
                col.prop(array_modifier, '["Input_7"]', text = "Radius")
                col.prop(array_modifier, '["Input_13"]', text = "Rotation")
                col.prop(array_modifier, '["Input_9"]', text = "Random Position")
                col.prop(array_modifier, '["Input_11"]', text = "Random Rotation")
                col.prop(array_modifier, '["Input_17"]', text = "Min Scale")
                col.prop(array_modifier, '["Input_19"]', text = "Max Scale")
                col.prop(array_modifier, '["Input_15"]', text = "Align to Center")
                col.prop(array_modifier, '["Input_21"]', text = "Seed")

        if operator_type == "BOOLEAN":
            obj_target = bpy.data.objects[convert_to_list[1]]
            baga_mesh = bpy.data.objects[convert_to_list[2]]

            col.label(text=("Boolean :" + obj_target.name))

            col.prop(obj_target.modifiers[convert_to_list[4]], 'use_self', text="Use Self")
            col.prop(obj_target.modifiers[convert_to_list[3]], 'width', text="Bevel Width")
            col.prop(obj_target.modifiers[convert_to_list[3]], 'segments', text="Segment Count")
            row = layout.row()
            row.prop(baga_mesh.modifiers[convert_to_list[5]], 'use_axis', text="Axis")

        if operator_type == "WALL":
            obj_target = bpy.data.objects[convert_to_list[1]]

            col.label(text=("Wall : " + obj_target.name))

            box.prop(obj_target.modifiers[convert_to_list[2]], 'screw_offset', text="Wall Height")
            box.prop(obj_target.modifiers[convert_to_list[3]], 'thickness', text="Wall Thickness")
            box.prop(obj_target.modifiers[convert_to_list[3]], 'offset', text="Wall Axis Offset")

        if operator_type == "SCATTER":
            obj_target = bpy.data.objects[convert_to_list[1]]

            col.label(text=("Scatter : " + obj_target.name))

            scatter_modifier = obj_target.modifiers[convert_to_list[2]]
            col.prop(scatter_modifier, '["Input_5"]', text = "Distance Min")
            col.prop(scatter_modifier, '["Input_7"]', text = "Density")
            box.label(text="Random")
            box.prop(scatter_modifier, '["Input_9"]', text = "Scale Min")
            box.prop(scatter_modifier, '["Input_11"]', text = "Scale Max")
            box.prop(scatter_modifier, '["Input_13"]', text = "Random Rotation")
            box.prop(scatter_modifier, '["Input_15"]', text = "Random Position")
            col.prop(scatter_modifier, '["Input_17"]', text = "Align to Normal")
            col.prop(scatter_modifier, '["Input_19"]', text = "Seed")

        if operator_type == "DISPLACE":
            obj_target = bpy.data.objects[convert_to_list[1]]
            texture = bpy.data.textures[convert_to_list[4]]

            col.label(text=("Displace : " + obj_target.name))

            box.label(text="Subdivision")
            box.prop(obj_target.modifiers[convert_to_list[2]], 'subdivision_type', text="Type")
            box.prop(obj_target.modifiers[convert_to_list[2]], 'levels', text="Subdivision")
            box.prop(obj_target.modifiers[convert_to_list[2]], 'render_levels', text="Subdivision Render")
            box = layout.box()
            box.label(text="Displace")
            box.prop(obj_target.modifiers[convert_to_list[3]], 'direction', text="Direction")
            box.prop(obj_target.modifiers[convert_to_list[3]], 'strength', text="Strength")
            box.prop(obj_target.modifiers[convert_to_list[3]], 'mid_level', text="Midlevel")
            box = layout.box()
            box.label(text="Texture")
            box.prop(texture, 'type', text="Type")
            box.prop(obj_target.modifiers[convert_to_list[3]], 'texture_coords', text="Mapping")
            box.prop(texture, 'noise_scale', text="Scale")
            box.prop(texture.color_ramp.elements[0], 'position', text="Ramp Min")
            box.prop(texture.color_ramp.elements[1], 'position', text="Ramp Max")


            #col.prop(obj_target.modifiers[convert_to_list[4]], 'offset', text="Wall Axis Offset")

        if operator_type == "WINDOW":
            obj_target = bpy.data.objects[convert_to_list[1]]

            col.label(text=("Window : " + obj_target.name))

            box.prop(obj_target.modifiers[convert_to_list[3]], 'strength', text="Offset")
            box.prop(obj_target.modifiers[convert_to_list[4]], 'thickness', text="Window Size")
            box.prop(obj_target.modifiers[convert_to_list[4]], 'offset', text="Window Offset")
            box.prop(obj_target.modifiers[convert_to_list[5]], 'width', text="Window Bevel")
            box.prop(obj_target.modifiers[convert_to_list[2]], 'merge_threshold', text="Merge Distance")

        if operator_type == "CURVE":
            obj_target = bpy.data.objects[convert_to_list[1]]

            col.label(text=("Auto Array on Curve : " + obj_target.name))

            col.prop(obj_target.modifiers[convert_to_list[3]], 'deform_axis', text="Axis")
            box.prop(obj_target.modifiers[convert_to_list[2]], 'use_relative_offset', text="Use Relative Offset")
            box.prop(obj_target.modifiers[convert_to_list[2]], 'relative_offset_displace', text="Ralative Offset")
            box = layout.box()
            box.prop(obj_target.modifiers[convert_to_list[2]], 'use_constant_offset', text="Use Constant Offset")
            box.prop(obj_target.modifiers[convert_to_list[2]], 'constant_offset_displace', text="Constant Offset")

        if operator_type == "SCATTERPAINT":
            obj_target = bpy.data.objects[convert_to_list[1]]

            col.label(text=("Scatter Paint : " + obj_target.name))

            scatterpaint_modifier = obj_target.modifiers[convert_to_list[2]]
            box.prop(scatterpaint_modifier, '["Input_5"]', text = "Distance Min")
            box.prop(scatterpaint_modifier, '["Input_7"]', text = "Density")
            box.prop(scatterpaint_modifier, '["Input_9"]', text = "Scale Min")
            box.prop(scatterpaint_modifier, '["Input_11"]', text = "Scale Max")
            box.prop(scatterpaint_modifier, '["Input_13"]', text = "Random Rotation")
            box.prop(scatterpaint_modifier, '["Input_15"]', text = "Align to Normal")
            box.prop(scatterpaint_modifier, '["Input_17"]', text = "Seed")

            col = layout.column(align=True)
            col.scale_y = 2.0

            if bpy.context.object.mode == 'OBJECT':
                col.operator("switch.mode", text= "Paint !")

            if bpy.context.object.mode == 'WEIGHT_PAINT':
                if bpy.context.scene.tool_settings.unified_paint_settings.weight < 1:
                    col.operator("invert.paint", text="ADD")
                else:
                    col.operator("invert.paint", text="REMOVE")

                col.scale_y = 1
                col.operator("clean.paint", text= "CLEAN PAINT")
                col = layout.column()
                col.scale_y = 2
                col.operator("switch.mode", text="EXIT !")

        else:
            box.label(text="BagaPie : Press J")


class SwitchMode(Operator):
    bl_idname = "switch.mode"
    bl_label = "Switch Object Mode"
    def execute(self, context):
        bpy.ops.paint.weight_paint_toggle()
        return {'FINISHED'}

class InvertPaint(Operator):
    bl_idname = "invert.paint"
    bl_label = "Invert Weight Paint"
    def execute(self, context):
        weight_value = bpy.context.scene.tool_settings.unified_paint_settings.weight
        bpy.context.scene.tool_settings.unified_paint_settings.weight = weight_value*(-1)+1
        return {'FINISHED'}

class CleanWPaint(Operator):
    bl_idname = "clean.paint"
    bl_label = "Clean Weight Paint"
    def execute(self, context):
        bpy.ops.object.editmode_toggle()
        bpy.ops.mesh.select_all(action='SELECT')
        bpy.ops.object.vertex_group_remove_from(use_all_groups=False)
        bpy.ops.paint.weight_paint_toggle()
        if bpy.context.scene.tool_settings.unified_paint_settings.weight < 1:
            bpy.ops.invert.paint()
        return {'FINISHED'}

# _______________________________________________ OPERATOR / BAGA MODIFIER

class MoArray(Operator):
    bl_idname = "wm.array"
    bl_label = "Array"
    bl_options = {'REGISTER', 'UNDO'}
#UI PANEL
    array_type: bpy.props.EnumProperty(
        name="Array Type",
        items=[('LINE', "Line",""),
               ('GRID', "Grid",""),
               ('CIRCLE', "Circle","")
               ],
        default='LINE'
    )
    array_count: bpy.props.IntProperty(
        name="Count",
        default=2,
        min=1
    )
    array_count_x: bpy.props.IntProperty(
        name="Count X",
        default=2,
        min=1
    )
    array_count_y: bpy.props.IntProperty(
        name="Count Y",
        default=2,
        min=1
    )
    array_count_circle: bpy.props.IntProperty(
        name="Count",
        default=6,
        min=1
    )
    array_offset: bpy.props.FloatVectorProperty(
        name="Offset",
        default=[1, 0, 0]
    )
    array_offset_x: bpy.props.FloatProperty(
        name="Offset X",
        default=1,
    )
    array_offset_y: bpy.props.FloatProperty(
        name="Offset Y",
        default=1,
    )
    array_radius: bpy.props.FloatProperty(
        name="Radius",
        default=1,
        min=0
    )
    array_randpos: bpy.props.FloatVectorProperty(
        name="Random Position",
        default=[0, 0, 0]
    )
    array_randrot: bpy.props.FloatVectorProperty(
        name="Random Rotation",
        default=[0, 0, 0]
    )
    array_rotation: bpy.props.FloatVectorProperty(
        name="Rotation",
        default=[0, 0, 0]
    )
    array_align: bpy.props.FloatProperty(
        name="Align to Center",
        default=1,
        min=0,
        max=1
    )
    array_randscale_min: bpy.props.FloatProperty(
        name="Min Scale",
        default=1,
        min=0
    )
    array_randscale_max: bpy.props.FloatProperty(
        name="Max Scale",
        default=1,
        min=0
    )
    seed: bpy.props.IntProperty(
        name="Seed",
        default=1,
        min=0
    )

    def draw(self, context):
        layout = self.layout
        col = layout.column_flow(align=True)

        row = col.row(align=True)
        box = layout.box()
        box.prop(self, "array_type")

        if self.array_type == 'LINE':
            box.prop(self, "array_count")
            box = layout.box()
            box.prop(self, "array_offset")
            box.prop(self, "array_randpos")
            box.prop(self, "array_randrot")
            box.prop(self, "array_randscale_min")
            box.prop(self, "array_randscale_max")
            box.prop(self, "seed")

        if self.array_type == 'GRID':
            box.prop(self, "array_count_x")
            box.prop(self, "array_count_y")
            box = layout.box()
            box.prop(self, "array_offset_x")
            box.prop(self, "array_offset_y")
            box.prop(self, "array_randpos")
            box.prop(self, "array_randrot")
            box.prop(self, "array_randscale_min")
            box.prop(self, "array_randscale_max")
            box.prop(self, "seed")

        if self.array_type == 'CIRCLE':
            box.prop(self, "array_count_circle")
            box = layout.box()
            box.prop(self, "array_radius")
            box.prop(self, "array_rotation")
            box.prop(self, "array_randpos")
            box.prop(self, "array_randrot")
            box.prop(self, "array_randscale_min")
            box.prop(self, "array_randscale_max")
            box.prop(self, "array_align")
            box.prop(self, "seed")

    def execute(self, context):

        skip_modifier_creation = bpy.context.active_object.modifiers.get("BagaArray")   # Meh .........
        if skip_modifier_creation is None:                                              # Meh .........

            # FIRST STEP
            array_obj = bpy.context.selected_objects # Get object for array
            target = bpy.context.active_object # Get active object
            bpy.ops.mesh.primitive_plane_add() # Create new object for Array modifier
            array_target = bpy.context.active_object
            array_target.name = "BagaArray_" + target.name
            array_target.location = target.location

        # COLLECTION

            if bpy.data.collections.get("BagaPie_Mesh") is None:  # create collection
                main_coll = bpy.data.collections.new("BagaPie_Mesh")
                bpy.context.scene.collection.children.link(main_coll)
                win_coll = bpy.data.collections.new("BagaPie_Array_" + target.name)
                main_coll.children.link(win_coll)
            else:
                win_coll = bpy.data.collections.new("BagaPie_Array_" + target.name)
                main_coll = bpy.data.collections["BagaPie_Mesh"]
                main_coll.children.link(win_coll)

            if bpy.data.collections.get("BagaPie_Mesh") is None:  # create collection
                main_coll = bpy.data.collections.new("BagaPie_Mesh")
                bpy.context.scene.collection.children.link(main_coll)
                array_coll = bpy.data.collections.new("BagaPie_Array")
                main_coll.children.link(array_coll)
            elif bpy.data.collections.get("BagaPie_Array") is None:
                array_coll = bpy.data.collections.new("BagaPie_Array")
                main_coll = bpy.data.collections["BagaPie_Mesh"]
                main_coll.children.link(array_coll)
            else:
                array_coll = bpy.data.collections.get("BagaPie_Array")

            instance_coll = win_coll  # I know ...

            for ob in array_obj:
                instance_coll.objects.link(ob)

            for collection in bpy.data.collections:
                if array_target.name in collection.objects:
                    collection.objects.unlink(array_target)

            array_coll.objects.link(array_target)

        # CREATE ARRAY MODIFIER AND NODE TREE
            # ADD MODIFIER
            new = bpy.data.objects[array_target.name].modifiers.new
            array = new(name="BagaArray_" + target.name, type='NODES')
            array_nde_group = array.node_group
            array_nde_group.name = "BagaArray_" + target.name

            # GET IN AND OUT NODES
            array_nde_inp = array_nde_group.nodes[0]
            array_nde_out = array_nde_group.nodes[1]

            # LINE TYPE ARRAY
            if self.array_type == 'LINE':
                # ADD NODES
                array_nde_line = array_nde_group.nodes.new('GeometryNodeMeshLine')                  # Mesh Line Primitive
                array_nde_vecmathpos = array_nde_group.nodes.new('ShaderNodeVectorMath')            # Vector Math Position
                array_nde_vecmathrot = array_nde_group.nodes.new('ShaderNodeVectorMath')            # Vector Math Rotation
                array_nde_randpos = array_nde_group.nodes.new('GeometryNodeAttributeRandomize')     # Randomize Position
                array_nde_randrot = array_nde_group.nodes.new('GeometryNodeAttributeRandomize')     # Randomize Rotation
                array_nde_randscale = array_nde_group.nodes.new('GeometryNodeAttributeRandomize')   # Randomize Scale
                array_nde_poininst = array_nde_group.nodes.new('GeometryNodePointInstance')         # Point Instance


                # POSITION NODES
                array_nde_inp.location = (0, 0)  # Group input
                array_nde_out.location = (1200, 0)  # Group output
                array_nde_line.location = (200, 150)
                array_nde_vecmathpos.location = (200, -120)
                array_nde_vecmathrot.location = (200, -320)
                array_nde_randpos.location = (400, 0)
                array_nde_randrot.location = (600, 0)
                array_nde_randscale.location = (800, 0)
                array_nde_poininst.location = (1000, 0)


                # LINK NODES,UI & CONFIG
                new_link = array_nde_group.links

                # Config Nodes (Values)

                array_nde_vecmathpos.operation = 'MULTIPLY'             # Vector Math Position
                array_nde_vecmathpos.inputs[1].default_value[0] = (-1)
                array_nde_vecmathpos.inputs[1].default_value[1] = (-1)
                array_nde_vecmathpos.inputs[1].default_value[2] = (-1)
                array_nde_vecmathrot.operation = 'MULTIPLY'             # Vector Math Rotation
                array_nde_vecmathrot.inputs[1].default_value[0] = (-1)
                array_nde_vecmathrot.inputs[1].default_value[1] = (-1)
                array_nde_vecmathrot.inputs[1].default_value[2] = (-1)
                array_nde_randpos.data_type = 'FLOAT_VECTOR'            # Random Position
                array_nde_randpos.inputs[1].default_value = "position"
                array_nde_randpos.operation = 'ADD'
                array_nde_randrot.data_type = 'FLOAT_VECTOR'            # Random Rotation
                array_nde_randrot.inputs[1].default_value = "rotation"
                array_nde_randscale.data_type = 'FLOAT'                   # Random Scale
                array_nde_randscale.inputs[1].default_value = "scale"
                array_nde_poininst.instance_type = 'COLLECTION'         # Point Instance
                array_nde_poininst.use_whole_collection = False
                array_nde_poininst.inputs[2].default_value = instance_coll


                # UI geometry node, add inpits on Group Input

                array_nde_group.inputs.new(type="NodeSocketInt", name="Count")
                array_nde_group.inputs[1].min_value = 1
                array_nde_group.inputs[1].default_value = 2
                array_nde_group.inputs.new(type="NodeSocketVector", name="Offset")
                array_nde_group.inputs[2].default_value[0] = 1
                array_nde_group.inputs[2].default_value[1] = 0
                array_nde_group.inputs[2].default_value[2] = 0
                array_nde_group.inputs.new(type="NodeSocketVector", name="Random Position")
                array_nde_group.inputs[3].default_value[0] = 0
                array_nde_group.inputs[3].default_value[1] = 0
                array_nde_group.inputs[3].default_value[2] = 0
                array_nde_group.inputs.new(type="NodeSocketVector", name="Random Rotation")
                array_nde_group.inputs[4].default_value[0] = 0
                array_nde_group.inputs[4].default_value[1] = 0
                array_nde_group.inputs[4].default_value[2] = 0
                array_nde_group.inputs.new(type="NodeSocketFloat", name="Min Scale")
                array_nde_group.inputs[5].min_value = 0
                array_nde_group.inputs[5].default_value = 1
                array_nde_group.inputs.new(type="NodeSocketFloat", name="Max Scale")
                array_nde_group.inputs[6].min_value = 0
                array_nde_group.inputs[6].default_value = 1
                array_nde_group.inputs.new(type="NodeSocketInt", name="Seed")
                array_nde_group.inputs[7].min_value = 0
                array_nde_group.inputs[7].default_value = 1

                # Geometry and vector links

                new_link.new(array_nde_line.outputs[0], array_nde_randpos.inputs[0])        # Geometry link
                new_link.new(array_nde_randpos.outputs[0], array_nde_randrot.inputs[0])
                new_link.new(array_nde_randrot.outputs[0], array_nde_randscale.inputs[0])
                new_link.new(array_nde_randscale.outputs[0], array_nde_poininst.inputs[0])
                new_link.new(array_nde_poininst.outputs[0], array_nde_out.inputs[0])

                new_link.new(array_nde_vecmathpos.outputs[0], array_nde_randpos.inputs[3])        # Vector link
                new_link.new(array_nde_vecmathrot.outputs[0], array_nde_randrot.inputs[3])

                # Group Input links

                new_link.new(array_nde_inp.outputs[1], array_nde_line.inputs[0])
                new_link.new(array_nde_inp.outputs[2], array_nde_line.inputs[3])
                new_link.new(array_nde_inp.outputs[3], array_nde_vecmathpos.inputs[0])
                new_link.new(array_nde_inp.outputs[4], array_nde_vecmathrot.inputs[0])
                new_link.new(array_nde_inp.outputs[3], array_nde_randpos.inputs[2])
                new_link.new(array_nde_inp.outputs[4], array_nde_randrot.inputs[2])
                new_link.new(array_nde_inp.outputs[5], array_nde_randscale.inputs[4])
                new_link.new(array_nde_inp.outputs[6], array_nde_randscale.inputs[5])
                new_link.new(array_nde_inp.outputs[7], array_nde_randpos.inputs[8])
                new_link.new(array_nde_inp.outputs[7], array_nde_randrot.inputs[8])
                new_link.new(array_nde_inp.outputs[7], array_nde_randscale.inputs[8])
                new_link.new(array_nde_inp.outputs[7], array_nde_poininst.inputs[3])

            # SCATTER MODIFIER SET VALUE
                array_modifier = array
                array_modifier["Input_5"] = self.array_count
                array_modifier["Input_7"][0] = self.array_offset[0]
                array_modifier["Input_7"][1] = self.array_offset[1]
                array_modifier["Input_7"][2] = self.array_offset[2]
                array_modifier["Input_9"][0] = self.array_randpos[0]
                array_modifier["Input_9"][1] = self.array_randpos[1]
                array_modifier["Input_9"][2] = self.array_randpos[2]
                array_modifier["Input_11"][0] = self.array_randrot[0]
                array_modifier["Input_11"][1] = self.array_randrot[1]
                array_modifier["Input_11"][2] = self.array_randrot[2]
                array_modifier["Input_13"] = self.array_randscale_min
                array_modifier["Input_15"] = self.array_randscale_max
                array_modifier["Input_17"] = self.seed

                array_variables = ["ARRAY",                              # CUSTOM PROPERTY :
                                  array_target.name,    # Target
                                  self.array_type,
                                  array_modifier.name,
                                  ]
                context.scene.bagapieValue = ""
                for var in array_variables:
                    context.scene.bagapieValue = context.scene.bagapieValue + var + " "

            # GRID TYPE ARRAY
            if self.array_type == 'GRID':
                # ADD NODES

                array_nde_math_sub_a = array_nde_group.nodes.new('ShaderNodeMath')                  # Math Sub A
                array_nde_math_sub_b = array_nde_group.nodes.new('ShaderNodeMath')                  # Math Sub B
                array_nde_math_mul_a = array_nde_group.nodes.new('ShaderNodeMath')                  # Math Sub A
                array_nde_math_mul_b = array_nde_group.nodes.new('ShaderNodeMath')                  # Math Sub B
                array_nde_math_mul_c = array_nde_group.nodes.new('ShaderNodeMath')                  # Math Sub C
                array_nde_math_mul_d = array_nde_group.nodes.new('ShaderNodeMath')                  # Math Sub D
                array_nde_combxyz = array_nde_group.nodes.new('ShaderNodeCombineXYZ')               # Combine XYZ
                array_nde_grid = array_nde_group.nodes.new('GeometryNodeMeshGrid')                  # Mesh Grid Primitive
                array_nde_vecmathpos = array_nde_group.nodes.new('ShaderNodeVectorMath')            # Vector Math Position
                array_nde_vecmathrot = array_nde_group.nodes.new('ShaderNodeVectorMath')            # Vector Math Rotation
                array_nde_transform = array_nde_group.nodes.new('GeometryNodeTransform')           # Transform
                array_nde_randpos = array_nde_group.nodes.new('GeometryNodeAttributeRandomize')     # Randomize Position
                array_nde_randrot = array_nde_group.nodes.new('GeometryNodeAttributeRandomize')     # Randomize Rotation
                array_nde_randscale = array_nde_group.nodes.new('GeometryNodeAttributeRandomize')     # Randomize Scale
                array_nde_poininst = array_nde_group.nodes.new('GeometryNodePointInstance')         # Point Instance


                # POSITION NODES
                array_nde_inp.location = (0, 0)             # Group input
                array_nde_out.location = (2000, 0)          # Group output
                array_nde_math_sub_a.location = (200, 0)  # Math :
                array_nde_math_sub_b.location = (200, -170)
                array_nde_math_mul_a.location = (400, 0)
                array_nde_math_mul_b.location = (400, -170)
                array_nde_math_mul_c.location = (600, 0)
                array_nde_math_mul_d.location = (600, -170)

                array_nde_combxyz.location = (800, 0)
                array_nde_grid.location = (800, -130)
                array_nde_vecmathpos.location = (800, -300)
                array_nde_vecmathrot.location = (800, -500)

                array_nde_transform.location = (1000, 0)
                array_nde_randpos.location = (1200, 0)
                array_nde_randrot.location = (1400, 0)
                array_nde_randscale.location = (1600, 0)
                array_nde_poininst.location = (1800, 0)


                # LINK NODES,UI & CONFIG
                new_link = array_nde_group.links

                # Config Nodes (Values)

                array_nde_math_sub_a.operation = 'SUBTRACT'             # Math
                array_nde_math_sub_a.inputs[1].default_value = 1
                array_nde_math_sub_b.operation = 'SUBTRACT'
                array_nde_math_sub_b.inputs[1].default_value = 1
                array_nde_math_mul_a.operation = 'MULTIPLY'
                array_nde_math_mul_b.operation = 'MULTIPLY'
                array_nde_math_mul_c.operation = 'MULTIPLY'
                array_nde_math_mul_d.operation = 'MULTIPLY'
                array_nde_vecmathpos.operation = 'MULTIPLY'             # Vector Math Position
                array_nde_vecmathpos.inputs[1].default_value[0] = (-1)
                array_nde_vecmathpos.inputs[1].default_value[1] = (-1)
                array_nde_vecmathpos.inputs[1].default_value[2] = (-1)
                array_nde_vecmathrot.operation = 'MULTIPLY'             # Vector Math Rotation
                array_nde_vecmathrot.inputs[1].default_value[0] = (-1)
                array_nde_vecmathrot.inputs[1].default_value[1] = (-1)
                array_nde_vecmathrot.inputs[1].default_value[2] = (-1)
                array_nde_randpos.data_type = 'FLOAT_VECTOR'            # Random Position
                array_nde_randpos.inputs[1].default_value = "position"
                array_nde_randpos.operation = 'ADD'
                array_nde_randrot.data_type = 'FLOAT_VECTOR'            # Random Rotation
                array_nde_randrot.inputs[1].default_value = "rotation"
                array_nde_randscale.inputs[1].default_value = "scale"     # Random Scale
                array_nde_poininst.instance_type = 'COLLECTION'         # Point Instance
                array_nde_poininst.use_whole_collection = False
                array_nde_poininst.inputs[2].default_value = instance_coll

                # UI geometry node, add inpits on Group Input

                array_nde_group.inputs.new(type="NodeSocketFloat", name="Distance X")
                array_nde_group.inputs[1].default_value = 1
                array_nde_group.inputs.new(type="NodeSocketInt", name="Count X")
                array_nde_group.inputs[2].min_value = 1
                array_nde_group.inputs[2].default_value = 2
                array_nde_group.inputs.new(type="NodeSocketFloat", name="Distance Y")
                array_nde_group.inputs[3].default_value = 1
                array_nde_group.inputs.new(type="NodeSocketInt", name="Count Y")
                array_nde_group.inputs[4].min_value = 1
                array_nde_group.inputs[4].default_value = 2
                array_nde_group.inputs.new(type="NodeSocketVector", name="Random Position")
                array_nde_group.inputs[5].default_value[0] = 0
                array_nde_group.inputs[5].default_value[1] = 0
                array_nde_group.inputs[5].default_value[2] = 0
                array_nde_group.inputs.new(type="NodeSocketVector", name="Random Rotation")
                array_nde_group.inputs[6].default_value[0] = 0
                array_nde_group.inputs[6].default_value[1] = 0
                array_nde_group.inputs[6].default_value[2] = 0
                array_nde_group.inputs.new(type="NodeSocketFloat", name="Min Scale")
                array_nde_group.inputs[7].min_value = 0
                array_nde_group.inputs[7].default_value = 1
                array_nde_group.inputs.new(type="NodeSocketFloat", name="Min Scale")
                array_nde_group.inputs[8].min_value = 0
                array_nde_group.inputs[8].default_value = 1
                array_nde_group.inputs.new(type="NodeSocketInt", name="Seed")
                array_nde_group.inputs[8].min_value = 0
                array_nde_group.inputs[8].default_value = 1

                # Geometry and vector links

                new_link.new(array_nde_math_sub_a.outputs[0], array_nde_math_mul_a.inputs[1])   # Math link
                new_link.new(array_nde_math_mul_a.outputs[0], array_nde_math_mul_c.inputs[0])
                new_link.new(array_nde_math_mul_c.outputs[0], array_nde_combxyz.inputs[0])
                new_link.new(array_nde_math_sub_b.outputs[0], array_nde_math_mul_b.inputs[1])
                new_link.new(array_nde_math_mul_b.outputs[0], array_nde_math_mul_d.inputs[0])
                new_link.new(array_nde_math_mul_d.outputs[0], array_nde_combxyz.inputs[1])
                new_link.new(array_nde_math_mul_a.outputs[0], array_nde_grid.inputs[0])
                new_link.new(array_nde_math_mul_b.outputs[0], array_nde_grid.inputs[1])

                new_link.new(array_nde_grid.outputs[0], array_nde_transform.inputs[0])          # Geometry link
                new_link.new(array_nde_transform.outputs[0], array_nde_randpos.inputs[0])
                new_link.new(array_nde_randpos.outputs[0], array_nde_randrot.inputs[0])
                new_link.new(array_nde_randrot.outputs[0], array_nde_randscale.inputs[0])
                new_link.new(array_nde_randscale.outputs[0], array_nde_poininst.inputs[0])
                new_link.new(array_nde_poininst.outputs[0], array_nde_out.inputs[0])

                new_link.new(array_nde_combxyz.outputs[0], array_nde_transform.inputs[1])       # Vector link
                new_link.new(array_nde_vecmathpos.outputs[0], array_nde_randpos.inputs[3])
                new_link.new(array_nde_vecmathrot.outputs[0], array_nde_randrot.inputs[3])

                # Group Input links

                new_link.new(array_nde_inp.outputs[1], array_nde_math_mul_a.inputs[0])
                new_link.new(array_nde_inp.outputs[2], array_nde_math_sub_a.inputs[0])
                new_link.new(array_nde_inp.outputs[2], array_nde_grid.inputs[2])
                new_link.new(array_nde_inp.outputs[3], array_nde_math_mul_b.inputs[0])
                new_link.new(array_nde_inp.outputs[4], array_nde_math_sub_b.inputs[0])
                new_link.new(array_nde_inp.outputs[4], array_nde_grid.inputs[3])
                new_link.new(array_nde_inp.outputs[5], array_nde_randpos.inputs[2])
                new_link.new(array_nde_inp.outputs[5], array_nde_vecmathpos.inputs[0])
                new_link.new(array_nde_inp.outputs[6], array_nde_randrot.inputs[2])
                new_link.new(array_nde_inp.outputs[6], array_nde_vecmathrot.inputs[0])
                new_link.new(array_nde_inp.outputs[7], array_nde_randscale.inputs[4])
                new_link.new(array_nde_inp.outputs[8], array_nde_randscale.inputs[5])
                new_link.new(array_nde_inp.outputs[9], array_nde_randpos.inputs[8])
                new_link.new(array_nde_inp.outputs[9], array_nde_randrot.inputs[8])
                new_link.new(array_nde_inp.outputs[9], array_nde_randscale.inputs[8])
                new_link.new(array_nde_inp.outputs[9], array_nde_poininst.inputs[3])

            # SCATTER MODIFIER SET VALUE
                array_modifier = array # Meh ...
                array_modifier["Input_5"] = self.array_offset_x
                array_modifier["Input_7"] = self.array_count_x
                array_modifier["Input_9"] = self.array_offset_y
                array_modifier["Input_11"] = self.array_count_y
                array_modifier["Input_13"][0] = self.array_randpos[0]
                array_modifier["Input_13"][1] = self.array_randpos[1]
                array_modifier["Input_13"][2] = self.array_randpos[2]
                array_modifier["Input_15"][0] = self.array_randrot[0]
                array_modifier["Input_15"][1] = self.array_randrot[1]
                array_modifier["Input_15"][2] = self.array_randrot[2]
                array_modifier["Input_17"] = self.array_randscale_min
                array_modifier["Input_19"] = self.array_randscale_max
                array_modifier["Input_21"] = self.seed

                array_variables = ["ARRAY",  # CUSTOM PROPERTY :
                                  array_target.name,  # Target
                                  self.array_type,
                                  array_modifier.name,
                                  ]
                context.scene.bagapieValue = ""
                for var in array_variables:
                    context.scene.bagapieValue = context.scene.bagapieValue + var + " "

            # GRID TYPE ARRAY
            if self.array_type == 'CIRCLE':
                # ADD NODES

                array_nde_circle = array_nde_group.nodes.new('GeometryNodeMeshCircle')  # Mesh Circle Primitive
                array_nde_vecmathpos = array_nde_group.nodes.new('ShaderNodeVectorMath')  # Vector Math Position
                array_nde_vecmathrot = array_nde_group.nodes.new('ShaderNodeVectorMath')  # Vector Math Rotation
                array_nde_randpos = array_nde_group.nodes.new('GeometryNodeAttributeRandomize')  # Randomize Position
                array_nde_randrot = array_nde_group.nodes.new('GeometryNodeAttributeRandomize')  # Randomize Rotation
                array_nde_randscale = array_nde_group.nodes.new('GeometryNodeAttributeRandomize')  # Randomize Scale
                array_nde_align = array_nde_group.nodes.new('GeometryNodeAlignRotationToVector')  # Align on Axis
                array_nde_rotation = array_nde_group.nodes.new('GeometryNodeAttributeVectorMath')  # Rotation
                array_nde_poininst = array_nde_group.nodes.new('GeometryNodePointInstance')  # Point Instance

                # POSITION NODES
                array_nde_inp.location = (0, 0)  # Group input
                array_nde_out.location = (1600, 0)  # Group output
                array_nde_circle.location = (200, 30)
                array_nde_vecmathpos.location = (200, -120)
                array_nde_vecmathrot.location = (200, -320)
                array_nde_randpos.location = (400, 0)
                array_nde_randrot.location = (600, 0)
                array_nde_align.location = (800, 0)
                array_nde_rotation.location = (1000, 0)
                array_nde_randscale.location = (1200, 0)
                array_nde_poininst.location = (1400, 0)

                # LINK NODES,UI & CONFIG
                new_link = array_nde_group.links

                # Config Nodes (Values)

                array_nde_vecmathpos.operation = 'MULTIPLY'  # Vector Math Position
                array_nde_vecmathpos.inputs[1].default_value[0] = (-1)
                array_nde_vecmathpos.inputs[1].default_value[1] = (-1)
                array_nde_vecmathpos.inputs[1].default_value[2] = (-1)
                array_nde_vecmathrot.operation = 'MULTIPLY'  # Vector Math Rotation
                array_nde_vecmathrot.inputs[1].default_value[0] = (-1)
                array_nde_vecmathrot.inputs[1].default_value[1] = (-1)
                array_nde_vecmathrot.inputs[1].default_value[2] = (-1)
                array_nde_randpos.data_type = 'FLOAT_VECTOR'  # Random Position
                array_nde_randpos.inputs[1].default_value = "position"
                array_nde_randpos.operation = 'ADD'
                array_nde_randrot.data_type = 'FLOAT_VECTOR'  # Random Rotation
                array_nde_randrot.inputs[1].default_value = "rotation"
                array_nde_align.axis = 'Y'              # Align
                array_nde_align.input_type_vector = 'ATTRIBUTE'
                array_nde_align.inputs[3].default_value = "position"
                array_nde_rotation.operation = 'ADD'    # Rotation
                array_nde_rotation.input_type_b = 'VECTOR'
                array_nde_rotation.inputs[1].default_value = "rotation"
                array_nde_rotation.inputs[9].default_value = "rotation"
                array_nde_randscale.inputs[1].default_value = "scale"
                array_nde_poininst.instance_type = 'COLLECTION'  # Point Instance
                array_nde_poininst.use_whole_collection = False
                array_nde_poininst.inputs[2].default_value = instance_coll

                # UI geometry node, add inputs on Group Input

                array_nde_group.inputs.new(type="NodeSocketInt", name="Count")
                array_nde_group.inputs[1].min_value = 1
                array_nde_group.inputs[1].default_value = 2
                array_nde_group.inputs.new(type="NodeSocketFloat", name="Radius")
                array_nde_group.inputs[2].min_value = 0
                array_nde_group.inputs[2].default_value = 1
                array_nde_group.inputs.new(type="NodeSocketVector", name="Random Position")
                array_nde_group.inputs[3].default_value[0] = 0
                array_nde_group.inputs[3].default_value[1] = 0
                array_nde_group.inputs[3].default_value[2] = 0
                array_nde_group.inputs.new(type="NodeSocketVector", name="Random Rotation")
                array_nde_group.inputs[4].default_value[0] = 0
                array_nde_group.inputs[4].default_value[1] = 0
                array_nde_group.inputs[4].default_value[2] = 0
                array_nde_group.inputs.new(type="NodeSocketVector", name="Rotation")
                array_nde_group.inputs[5].default_value[0] = 0
                array_nde_group.inputs[5].default_value[1] = 0
                array_nde_group.inputs[5].default_value[2] = 0
                array_nde_group.inputs.new(type="NodeSocketFloat", name="Align to Center")
                array_nde_group.inputs[6].min_value = 0
                array_nde_group.inputs[6].max_value = 1
                array_nde_group.inputs[6].default_value = 0
                array_nde_group.inputs.new(type="NodeSocketFloat", name="Min Scale")
                array_nde_group.inputs[7].min_value = 0
                array_nde_group.inputs[7].default_value = 1
                array_nde_group.inputs.new(type="NodeSocketFloat", name="Max Scale")
                array_nde_group.inputs[8].min_value = 0
                array_nde_group.inputs[8].default_value = 1
                array_nde_group.inputs.new(type="NodeSocketInt", name="Seed")
                array_nde_group.inputs[9].min_value = 0
                array_nde_group.inputs[9].default_value = 1

                # Geometry and vector links

                new_link.new(array_nde_circle.outputs[0], array_nde_randpos.inputs[0])  # Geometry link
                new_link.new(array_nde_randpos.outputs[0], array_nde_randrot.inputs[0])
                new_link.new(array_nde_randrot.outputs[0], array_nde_align.inputs[0])
                new_link.new(array_nde_align.outputs[0], array_nde_rotation.inputs[0])
                new_link.new(array_nde_rotation.outputs[0], array_nde_randscale.inputs[0])
                new_link.new(array_nde_randscale.outputs[0], array_nde_poininst.inputs[0])
                new_link.new(array_nde_poininst.outputs[0], array_nde_out.inputs[0])

                new_link.new(array_nde_vecmathpos.outputs[0], array_nde_randpos.inputs[3])  # Vector link
                new_link.new(array_nde_vecmathrot.outputs[0], array_nde_randrot.inputs[3])

                # Group Input links

                new_link.new(array_nde_inp.outputs[1], array_nde_circle.inputs[0])
                new_link.new(array_nde_inp.outputs[2], array_nde_circle.inputs[1])
                new_link.new(array_nde_inp.outputs[3], array_nde_vecmathpos.inputs[0])
                new_link.new(array_nde_inp.outputs[4], array_nde_vecmathrot.inputs[0])
                new_link.new(array_nde_inp.outputs[3], array_nde_randpos.inputs[2])
                new_link.new(array_nde_inp.outputs[4], array_nde_randrot.inputs[2])
                new_link.new(array_nde_inp.outputs[6], array_nde_align.inputs[2])
                new_link.new(array_nde_inp.outputs[5], array_nde_rotation.inputs[4])
                new_link.new(array_nde_inp.outputs[7], array_nde_randscale.inputs[4])
                new_link.new(array_nde_inp.outputs[8], array_nde_randscale.inputs[5])
                new_link.new(array_nde_inp.outputs[9], array_nde_randpos.inputs[8])
                new_link.new(array_nde_inp.outputs[9], array_nde_randrot.inputs[8])
                new_link.new(array_nde_inp.outputs[9], array_nde_randscale.inputs[8])
                new_link.new(array_nde_inp.outputs[9], array_nde_poininst.inputs[3])

                # SCATTER MODIFIER SET VALUE
                array_modifier = array # Oups ! I did it again !
                array_modifier["Input_5"] = self.array_count_circle
                array_modifier["Input_7"] = self.array_radius
                array_modifier["Input_9"][0] = self.array_randpos[0]
                array_modifier["Input_9"][1] = self.array_randpos[1]
                array_modifier["Input_9"][2] = self.array_randpos[2]
                array_modifier["Input_11"][0] = self.array_randrot[0]
                array_modifier["Input_11"][1] = self.array_randrot[1]
                array_modifier["Input_11"][2] = self.array_randrot[2]
                array_modifier["Input_17"] = self.array_randscale_min
                array_modifier["Input_19"] = self.array_randscale_max
                array_modifier["Input_13"][0] = self.array_rotation[0]
                array_modifier["Input_13"][1] = self.array_rotation[1]
                array_modifier["Input_13"][2] = self.array_rotation[2]
                array_modifier["Input_15"] = self.array_align
                array_modifier["Input_21"] = self.seed

                array_variables = ["ARRAY",  # CUSTOM PROPERTY :
                                  array_target.name,  # Target
                                  self.array_type,
                                  array_modifier.name,
                                  ]
                context.scene.bagapieValue = ""
                for var in array_variables:
                    context.scene.bagapieValue = context.scene.bagapieValue + var + " "

        return {'FINISHED'}


class MoBoolean(Operator):
    bl_idname = "wm.boolean"
    bl_label = "Boolean"
    bl_options = {'REGISTER', 'UNDO'}

    bool_use_self: bpy.props.BoolProperty(
        name="Use Self",
        default=True
    )
    bool_use_bevel_segcount: bpy.props.IntProperty(
        name="Segment Count",
        default=3,
        min=1,
        soft_max=10,
    )
    bool_use_bevel_size: bpy.props.FloatProperty(
        name="Bevel Size",
        default=0,
        min=0.0001,
    )
    bool_use_mirror_x: bpy.props.BoolProperty(
        name="X",
        default=False
        )
    bool_use_mirror_y: bpy.props.BoolProperty(
        name="Y",
        default=False
    )
    bool_use_mirror_z: bpy.props.BoolProperty(
        name="Z",
        default=False
    )

    def execute(self, context):

        if bpy.data.collections.get("BagaPie_Mesh") is None:
            main_coll = bpy.data.collections.new("BagaPie_Mesh")
            bpy.context.scene.collection.children.link(main_coll)
            bool_coll = bpy.data.collections.new("BagaPie_Boolean")
            main_coll.children.link(bool_coll)
        elif bpy.data.collections.get("BagaPie_Boolean") is None:
            bool_coll = bpy.data.collections.new("BagaPie_Boolean")
            main_coll = bpy.data.collections["BagaPie_Mesh"]
            main_coll.children.link(bool_coll)

        target = bpy.context.active_object
        new = bpy.data.objects[target.name].modifiers.new
    # TARGET
        bool_bool = new(name='BagaBool', type='BOOLEAN')
        # ADD BEVEL

        bool_bev = new(name='BagaBevel', type='BEVEL')
        bool_bev.segments = self.bool_use_bevel_segcount
        bool_bev.width = self.bool_use_bevel_size

        bpy.ops.mesh.primitive_plane_add(size=2, enter_editmode=True, align='WORLD',
                                         location=target.location, scale=(1, 1, 1))
        bpy.ops.mesh.delete(type='VERT')
        bpy.ops.object.editmode_toggle()
        bool_obj = bpy.context.object
        bool_obj.name = "BagaPie_Bool"
        bool_obj.display_type = 'BOUNDS'
        bool_obj_vis = bool_obj.cycles_visibility
        bool_obj_vis.camera = False
        bool_obj_vis.diffuse = False
        bool_obj_vis.glossy = False
        bool_obj_vis.transmission = False
        bool_obj_vis.scatter = False
        bool_obj_vis.shadow = False
        bool_coll = bpy.data.collections["BagaPie_Boolean"]
        bpy.ops.collection.objects_remove_all()
        bool_coll.objects.link(bool_obj)

    # BOOL OBJECT
        bool_add_modifier = bpy.data.objects[bool_obj.name].modifiers.new
        bool_disp = bool_add_modifier(name='BagaBool', type='DISPLACE')
        # ADD BOOLEAN
        bool_bool.object = bool_obj
        bool_bool.use_self = self.bool_use_self
        bool_disp.strength = 0.005
        bool_disp.show_in_editmode = True
        # ADD MIRROR
        bool_mirr = bool_add_modifier(name='BagaBool', type='MIRROR')
        bool_mirr.use_axis[0] = self.bool_use_mirror_x
        bool_mirr.use_axis[1] = self.bool_use_mirror_y
        bool_mirr.use_axis[2] = self.bool_use_mirror_z
        bool_mirr.mirror_object = target

        bpy.context.view_layer.objects.active = bool_obj
        bool_obj.parent = target
        bpy.ops.object.editmode_toggle()
        bpy.ops.wm.tool_set_by_id(name="builtin.primitive_cube_add")

        bool_variables = ["BOOLEAN",                        # CUSTOM PROPERTY :
                          target.name,
                          bool_obj.name,
                          bool_bev.name,
                          bool_bool.name,
                          bool_mirr.name,
                          ]
        context.scene.bagapieValue = ""
        for var in bool_variables:
            context.scene.bagapieValue = context.scene.bagapieValue + var + " "

        return {'FINISHED'}


class MoWall(Operator):
    bl_idname = "wm.wall"
    bl_label = "Wall"
    bl_options = {'REGISTER', 'UNDO'}

    wall_height: bpy.props.FloatProperty(
        name="Height",
        default=2.4,
    )
    wall_depth: bpy.props.FloatProperty(
        name="Depth",
        default=0.2,
    )
    wall_offset: bpy.props.FloatProperty(
        name="Offset",
        description="Placement du mur vis à vis de son axe.",
        default=0,
        min=0,
        soft_max=1,
    )

    def execute(self, context):
        target = bpy.context.active_object
        bpy.ops.object.shade_smooth()
        target.data.use_auto_smooth = True
        new = target.modifiers.new
        wall_weld = new(name='BagaScrew', type='WELD')
        screw = new(name='BagaScrew', type='SCREW')
        solid = new(name='BagaSolidify', type='SOLIDIFY')
        wall_weld.merge_threshold = 0.01
        screw.angle = 0
        screw.steps = 1
        screw.render_steps = 1
        screw.use_smooth_shade = False
        screw.use_normal_calculate = True
        screw.screw_offset = self.wall_height
        solid.solidify_mode = 'NON_MANIFOLD'
        solid.thickness = self.wall_depth
        solid.offset = self.wall_offset

        wall_variables = ["WALL",  # CUSTOM PROPERTY :
                          target.name,
                          screw.name,
                          solid.name,
                          ]
        context.scene.bagapieValue = ""
        for var in wall_variables:
            context.scene.bagapieValue = context.scene.bagapieValue + var + " " # replace by += ...

        return {'FINISHED'}


class MoScatter(Operator):
    bl_idname = "wm.scatter"
    bl_label = "Scatter"
    bl_options = {'REGISTER', 'UNDO'}

    # UI PANEL INPUTS
    distance_min: bpy.props.FloatProperty(
        name="Distance Min",
        default=0.1,
        min=0,
    )
    density: bpy.props.FloatProperty(
        name="Density",
        default=1,
        min=0,
    )
    scale_min: bpy.props.FloatProperty(
        name="Scale Min",
        default=1,
        min=0,
        soft_max=100,
    )
    scale_max: bpy.props.FloatProperty(
        name="Scale Max",
        default=1,
        min=0,
        soft_max=100,
    )
    random_rot: bpy.props.FloatVectorProperty(
        name="Randomize Rotation",
        default=[0, 0, 0],
    )
    random_pos: bpy.props.FloatVectorProperty(
        name="Randomize Position",
        default=[0, 0, 0],
    )
    align_to_normal: bpy.props.FloatProperty(
        name="Align to Normal",
        default=0,
        min=0,
        max=1,
    )
    seed: bpy.props.IntProperty(
        name="Seed",
        default=1,
        min=0,
    )

    def execute(self, context):

        target = bpy.context.active_object
        if target.modifiers.get("BagaScatter") is None:

        # COLLECTION
            if bpy.data.collections.get("BagaPie_Mesh") is None: #create collection
                main_coll = bpy.data.collections.new("BagaPie_Mesh")
                bpy.context.scene.collection.children.link(main_coll)
                scatt_coll = bpy.data.collections.new("BagaPie_Instance_"+target.name)
                main_coll.children.link(scatt_coll)
            else:
                scatt_coll = bpy.data.collections.new("BagaPie_Instance_"+target.name)
                main_coll = bpy.data.collections["BagaPie_Mesh"]
                main_coll.children.link(scatt_coll)




            obj = bpy.context.selected_objects #Add objects to coll instance
            obj.remove(target)
            for ob in obj:
                if ob.name not in scatt_coll.objects:
                    scatt_coll.objects.link(ob)
                else:
                    print(ob.name, "is already in BagaPie_Instance_"+target.name)


            # CREATE SCATTER MODIFIER
            if target.modifiers.get("BagaScatter") is None:

            # ADD MODIFIER
                new = bpy.data.objects[target.name].modifiers.new
                scatt = new(name='BagaScatter', type='NODES')
                scatt_nde_group = scatt.node_group
                scatt_nde_group.name = "BagaScatter"

            # GET IN AND OUT NODES
                scatt_nde_inp = scatt_nde_group.nodes[0]
                scatt_nde_out = scatt_nde_group.nodes[1]

            # ADD NODES
                scatt_nde_poidist = scatt_nde_group.nodes.new('GeometryNodePointDistribute')
                scatt_nde_randpos = scatt_nde_group.nodes.new('GeometryNodeAttributeRandomize')
                scatt_nde_randsca = scatt_nde_group.nodes.new('GeometryNodeAttributeRandomize')
                scatt_nde_randrot = scatt_nde_group.nodes.new('GeometryNodeAttributeRandomize')
                scatt_nde_alitovec = scatt_nde_group.nodes.new('GeometryNodeAlignRotationToVector')
                scatt_nde_insta = scatt_nde_group.nodes.new('GeometryNodePointInstance')
                scatt_nde_join = scatt_nde_group.nodes.new('GeometryNodeJoinGeometry')
                scatt_nde_vecmat = scatt_nde_group.nodes.new('ShaderNodeVectorMath')
                scatt_nde_vecmatpos = scatt_nde_group.nodes.new('ShaderNodeVectorMath')

            # POSITION NODES
                scatt_nde_inp.location = (0, 200)             # Group input
                scatt_nde_out.location = (1600, 200)          # Group output
                scatt_nde_poidist.location = (200, 200)     # Point distribute
                scatt_nde_randpos.location = (400,200)      # Randomize position
                scatt_nde_randsca.location = (600, 200)     # Randomize scale
                scatt_nde_randrot.location = (800, 200)     # Randomize rotation
                scatt_nde_alitovec.location = (1000, 200)   # Align rotation to vector
                scatt_nde_insta.location = (1200, 200)      # Point instance
                scatt_nde_join.location = (1400, 200)         # Join
                scatt_nde_vecmat.location = (200, 0)      # Vector math random rotation
                scatt_nde_vecmatpos.location = (200, -210)  # Vector math random position

            # LINK NODES,UI & CONFIG
                new_link = scatt_nde_group.links
                # Geometry path
                new_link.new(scatt_nde_inp.outputs[0], scatt_nde_poidist.inputs[0])
                new_link.new(scatt_nde_poidist.outputs[0], scatt_nde_randpos.inputs[0])
                new_link.new(scatt_nde_randpos.outputs[0], scatt_nde_randsca.inputs[0])
                new_link.new(scatt_nde_randsca.outputs[0], scatt_nde_randrot.inputs[0])
                new_link.new(scatt_nde_randrot.outputs[0], scatt_nde_alitovec.inputs[0])
                new_link.new(scatt_nde_alitovec.outputs[0], scatt_nde_insta.inputs[0])
                new_link.new(scatt_nde_insta.outputs[0], scatt_nde_join.inputs[0])
                new_link.new(scatt_nde_join.outputs[0], scatt_nde_out.inputs[0])
                new_link.new(scatt_nde_inp.outputs[0], scatt_nde_join.inputs[0])

                # Config Nodes
                scatt_nde_randpos.inputs[1].default_value = "position"
                scatt_nde_randpos.data_type = 'FLOAT_VECTOR'
                scatt_nde_randpos.operation = 'ADD'
                scatt_nde_randsca.inputs[1].default_value = "scale"
                scatt_nde_randrot.data_type = 'FLOAT_VECTOR'
                scatt_nde_randrot.inputs[1].default_value = "rotation"
                scatt_nde_alitovec.axis = 'Z'
                scatt_nde_alitovec.input_type_vector = 'ATTRIBUTE'
                scatt_nde_alitovec.inputs[3].default_value = "normal"
                scatt_nde_vecmat.operation = 'MULTIPLY'
                scatt_nde_vecmat.inputs[1].default_value[0] = (-1)
                scatt_nde_vecmat.inputs[1].default_value[1] = (-1)
                scatt_nde_vecmat.inputs[1].default_value[2] = (-1)
                scatt_nde_vecmatpos.operation = 'MULTIPLY'
                scatt_nde_vecmatpos.inputs[1].default_value[0] = (-1)
                scatt_nde_vecmatpos.inputs[1].default_value[1] = (-1)
                scatt_nde_vecmatpos.inputs[1].default_value[2] = (-1)
                scatt_nde_insta.instance_type = 'COLLECTION'
                scatt_nde_insta.use_whole_collection = False
                scatt_nde_insta.inputs[2].default_value = scatt_coll
                scatt_nde_poidist.distribute_method = 'POISSON'

                # UI geometry node, add inputs
                scatt_nde_group.inputs.new(type="NodeSocketFloat", name="Distance Min")
                scatt_nde_group.inputs[1].min_value = 0
                scatt_nde_group.inputs[1].default_value = 0
                scatt_nde_group.inputs.new(type="NodeSocketFloat", name="Density")
                scatt_nde_group.inputs[2].min_value = 0
                scatt_nde_group.inputs[2].default_value = 1
                scatt_nde_group.inputs.new(type="NodeSocketFloat", name="Scale Min")
                scatt_nde_group.inputs[3].default_value = 1
                scatt_nde_group.inputs.new(type="NodeSocketFloat", name="Scale Max")
                scatt_nde_group.inputs[4].default_value = 1
                scatt_nde_group.inputs.new(type="NodeSocketVector", name="Randomize Rotation")
                scatt_nde_group.inputs[5].default_value[0] = 0
                scatt_nde_group.inputs[5].default_value[1] = 0
                scatt_nde_group.inputs[5].default_value[2] = 0
                scatt_nde_group.inputs.new(type="NodeSocketVector", name="Randomize Position")
                scatt_nde_group.inputs[6].default_value[0] = 0
                scatt_nde_group.inputs[6].default_value[1] = 0
                scatt_nde_group.inputs[6].default_value[2] = 0
                scatt_nde_group.inputs.new(type="NodeSocketFloatFactor", name="Align to Normal")
                scatt_nde_group.inputs[7].min_value = 0
                scatt_nde_group.inputs[7].max_value = 1
                scatt_nde_group.inputs[7].default_value = 1
                scatt_nde_group.inputs.new(type="NodeSocketIntFactor", name="Seed")
                scatt_nde_group.inputs[8].min_value = 0
                scatt_nde_group.inputs[8].default_value = 1

                # Link nodes to group input node
                new_link.new(scatt_nde_inp.outputs[1], scatt_nde_poidist.inputs[1])
                new_link.new(scatt_nde_inp.outputs[8], scatt_nde_poidist.inputs[4])
                new_link.new(scatt_nde_inp.outputs[2], scatt_nde_poidist.inputs[2])
                new_link.new(scatt_nde_inp.outputs[3], scatt_nde_randsca.inputs[4])
                new_link.new(scatt_nde_inp.outputs[4], scatt_nde_randsca.inputs[5])
                new_link.new(scatt_nde_inp.outputs[7], scatt_nde_alitovec.inputs[2])
                new_link.new(scatt_nde_inp.outputs[5], scatt_nde_vecmat.inputs[0])
                new_link.new(scatt_nde_inp.outputs[5], scatt_nde_randrot.inputs[2])
                new_link.new(scatt_nde_inp.outputs[6], scatt_nde_vecmatpos.inputs[0])
                new_link.new(scatt_nde_inp.outputs[6], scatt_nde_randpos.inputs[2])
                new_link.new(scatt_nde_vecmat.outputs[0], scatt_nde_randrot.inputs[3])
                new_link.new(scatt_nde_vecmatpos.outputs[0], scatt_nde_randpos.inputs[3])

        # If Scatter Modifier are already present, all selected items are added to current Scatter Collection
        else:
            instance_coll = bpy.data.collections.get("BagaPie_Instance_"+target.name)

            obj = bpy.context.selected_objects  # Add objects to coll instance
            obj.remove(target)
            for ob in obj:
                if ob.name not in instance_coll.objects:
                    instance_coll.objects.link(ob)
                else:
                    print(ob.name, "is already in BagaPie_Instance_"+target.name)
            if not target.modifiers.get("BagaScatter").show_viewport:
                target.modifiers.get("BagaScatter").show_viewport = True


        # SCATTER MODIFIER SET VALUE
        scatter_modifier = bpy.context.object.modifiers["BagaScatter"]
        scatter_modifier["Input_5"] = self.distance_min
        scatter_modifier["Input_7"] = self.density
        scatter_modifier["Input_9"] = self.scale_min
        scatter_modifier["Input_11"] = self.scale_max
        scatter_modifier["Input_13"][0] = self.random_rot[0]
        scatter_modifier["Input_13"][1] = self.random_rot[1]
        scatter_modifier["Input_13"][2] = self.random_rot[2]
        scatter_modifier["Input_15"][0] = self.random_pos[0]
        scatter_modifier["Input_15"][1] = self.random_pos[1]
        scatter_modifier["Input_15"][2] = self.random_pos[2]
        scatter_modifier["Input_17"] = self.align_to_normal
        scatter_modifier["Input_19"] = self.seed

        scatter_variables = ["SCATTER",                              # CUSTOM PROPERTY :
                          target.name,    # Target
                          "BagaScatter",
                          ]
        context.scene.bagapieValue = ""
        for var in scatter_variables:
            context.scene.bagapieValue = context.scene.bagapieValue + var + " "

        return {'FINISHED'}


class MoDisplace(Operator):
    bl_idname = "wm.displace"
    bl_label = "Displace"
    bl_options = {'REGISTER', 'UNDO'}

    dir: bpy.props.EnumProperty(
        name="Dirrection",
        items=[('X', "X",""),
               ('Y', "Y",""),
               ('Z', "Z",""),
               ('NORMAL', "Normal",""),
               ('CUSTOM_NORMAL', "Custom Normal",""),
               ('RGB_TO_XYZ', "RGB to XYZ","")
               ],
        default='NORMAL'
    )
    str: bpy.props.FloatProperty(
        name="Strength",
        default=1,
        min=-100,
        max=100,
    )
    mid: bpy.props.FloatProperty(
        name="Midlevel",
        default=0.5,
        min=0,
        max=1,
    )
    # ADD TEXTURE
    disp_tex_type: bpy.props.EnumProperty(
        name="Texture Type",
        items=[('BLEND', "Blend",""),
               ('CLOUDS', "Clouds",""),
               ('DISTORTED_NOISE', "Distorted Noise",""),
               ('MAGIC', "Magic",""),
               ('MARBLE', "Marble",""),
               ('MUSGRAVE', "Musgrave",""),
               ('NOISE', "Noise",""),
               ('STUCCI', "Stucci",""),
               ('VORONOI', "Voronoi",""),
               ('WOOD', "Wood","")
               ],
        default='MUSGRAVE'
    )
    disp_tex_mapping: bpy.props.EnumProperty(
        name="Texture Mapping",
        items=[('LOCAL', "Local",""),
               ('GLOBAL', "Global",""),
               ('OBJECT', "Object",""),
               ('UV', "UV","")
               ],
        default='LOCAL',
    )
    disp_tex_size: bpy.props.FloatProperty(name="Texture Scale", default=0.5, min=0, soft_max=30)
    disp_tex_useramp: bpy.props.BoolProperty(name="Use ColorRamp", default=True)
    disp_tex_rampmin: bpy.props.FloatProperty(name="ColorRamp Min", default=0, min=0, max=1)
    disp_tex_rampmax: bpy.props.FloatProperty(name="ColorRamp Max", default=1, min=0, max=1)
    tex_type_A = ('CLOUDS','DISTORTED_NOISE','MARBLE','MUSGRAVE','STUCCI','VORONOI')

    # SUBDIVISION SURFACE
    disp_use_simplesub: bpy.props.BoolProperty(name="Simple Subdivision", default=False)
    disp_sub_count: bpy.props.IntProperty(name="Subdiv Count", default=2, min=1, max=6)

    def execute(self, context):
        target = bpy.context.active_object
        new = bpy.data.objects[target.name].modifiers.new

        subdiv = new(name='BagaSubdiv', type='SUBSURF')
        subdiv.levels = self.disp_sub_count
        subdiv.render_levels = self.disp_sub_count
        if self.disp_use_simplesub is True:
            subdiv.subdivision_type = 'SIMPLE'

        displace = new(name='BagaDisplace', type='DISPLACE')
        displace.direction = self.dir
        displace.strength = self.str
        displace.mid_level = self.mid

        texture = bpy.data.textures.new(name="BagaPie_Texture", type=self.disp_tex_type)
        if self.disp_tex_type in self.tex_type_A:
            texture.noise_scale = self.disp_tex_size
            texture.use_color_ramp = self.disp_tex_useramp
            if self.disp_tex_useramp is True:
                texture.color_ramp.elements[0].position = self.disp_tex_rampmin
                texture.color_ramp.elements[1].position = self.disp_tex_rampmax
        displace.texture = texture
        displace.texture_coords = self.disp_tex_mapping

        scatter_variables = ["DISPLACE",                              # CUSTOM PROPERTY :
                            target.name,    # Target
                            subdiv.name,
                            displace.name,
                            texture.name,
                            ]
        context.scene.bagapieValue = ""
        for var in scatter_variables:
            context.scene.bagapieValue = context.scene.bagapieValue + var + " "

        return {'FINISHED'}


class MoWindow(Operator):
    bl_idname = "wm.window"
    bl_label = "Window"
    bl_options = {'REGISTER', 'UNDO'}

    win_offset: bpy.props.FloatProperty(
        name="Offset",
        description="Position de la fenêtre.",
        default=0,
        soft_min=0,
        soft_max=10,
    )
    win_men_size: bpy.props.FloatProperty(
        name="Wire Size",
        description="Taille de menuiseries.",
        default=0.1,
        min=0,
        soft_max=0.5,
    )

    def execute(self, context):

    # CHECK AND CREATE COLLECTION
        if bpy.data.collections.get("BagaPie_Mesh") is None:
            main_coll = bpy.data.collections.new("BagaPie_Mesh")
            bpy.context.scene.collection.children.link(main_coll)
            win_coll = bpy.data.collections.new("BagaPie_Window")
            main_coll.children.link(win_coll)
        elif bpy.data.collections.get("BagaPie_Window") is None:
            win_coll = bpy.data.collections.new("BagaPie_Window")
            main_coll = bpy.data.collections["BagaPie_Mesh"]
            main_coll.children.link(win_coll)
        win_coll = bpy.data.collections['BagaPie_Window']

    # CREATE AND GET OBJECT
        target = bpy.context.object
        bpy.ops.mesh.primitive_plane_add()
        win = bpy.context.object
        win.name = "Baga_Window"
        bpy.ops.object.duplicate_move_linked()
        win_bool = bpy.context.object
        win_bool.name = "Baga_Window_Bool"

    # WINDOWS PRESET
        new = bpy.data.objects[win.name].modifiers.new
        win_weld = new(name='BagaWindow_Weld', type='WELD')
        win_disp = new(name='BagaWindow_Displace', type='DISPLACE')
        win_wire = new(name='BagaWindow_Wire', type='WIREFRAME')
        win_beve = new(name='BagaWindow_Bevel', type='BEVEL')
        win.parent = target

        obj_old_coll = win.users_collection
        for ob in obj_old_coll:
            ob.objects.unlink(win)
        win_coll.objects.link(win)

        win_weld.merge_threshold = 0.3
        win_weld.mode = 'CONNECTED'
        win_weld.show_on_cage = True

        win_disp.show_in_editmode = True
        win_disp.strength = self.win_offset

        win_wire.show_in_editmode = True
        win_wire.thickness = self.win_men_size
        win_wire.use_boundary = True
        win_wire.use_replace = False
        win_wire.material_offset = 1

        win_beve.width = 0.5
        win_beve.angle_limit = 1.55
        win_beve.profile_type = 'CUSTOM'


    # BOOLEAN PRESET
        new = bpy.data.objects[win_bool.name].modifiers.new
        win_bool_disp = new(name='BagaWindowBool_Displace', type='DISPLACE')
        win_bool_disp.show_in_editmode = True
        win_bool_disp.strength = 0.01
        win_bool.display_type = 'BOUNDS'
        win_bool.cycles_visibility.camera = False
        win_bool.cycles_visibility.diffuse = False
        win_bool.cycles_visibility.glossy = False
        win_bool.cycles_visibility.transmission = False
        win_bool.cycles_visibility.scatter = False
        win_bool.cycles_visibility.shadow = False
        win_bool.parent = target

        obj_old_coll = win_bool.users_collection
        for ob in obj_old_coll:
            ob.objects.unlink(win_bool)
        win_coll.objects.link(win_bool)

    # BOOLEAN ON TARGET (WALL)
        new = bpy.data.objects[target.name].modifiers.new
        target_bool = new(name='BagaWindow_Boolean', type='BOOLEAN')
        target_bool.show_in_editmode = True
        target_bool.object = win_bool

    # ADD MATERIAL
            # Glass
        mat_glass = bpy.data.materials.new(name="BagaPie_Glass")
        mat_glass.blend_method = 'HASHED'
        mat_glass.use_nodes = True
        mat_glass.diffuse_color = (0.34, 0.6, 0.8, 0.75)
        principled_node = mat_glass.node_tree.nodes.get('Principled BSDF')
        mat_glass_nodeout = mat_glass.node_tree.nodes.get('Material Output')
        mat_glass.node_tree.nodes.remove(principled_node)

        mat_glass_nodegloss = mat_glass.node_tree.nodes.new('ShaderNodeBsdfGlossy')
        mat_glass_nodetrans = mat_glass.node_tree.nodes.new('ShaderNodeBsdfTransparent')
        mat_glass_nodemix = mat_glass.node_tree.nodes.new('ShaderNodeMixShader')

        mat_glass_nodegloss.location = (-200, 150)
        mat_glass_nodetrans.location = (-200, 450)
        mat_glass_nodemix.location = (100, 300)

        mat_glass.node_tree.links.new(mat_glass_nodetrans.outputs[0], mat_glass_nodemix.inputs[1])
        mat_glass.node_tree.links.new(mat_glass_nodegloss.outputs[0], mat_glass_nodemix.inputs[2])
        mat_glass.node_tree.links.new(mat_glass_nodemix.outputs[0], mat_glass_nodeout.inputs[0])

        mat_glass_nodegloss.inputs[1].default_value = 0
        mat_glass_nodemix.inputs[0].default_value = 0.25

            #Window
        mat_win = bpy.data.materials.new(name="BagaPie_Window")
        mat_win.use_nodes = True
        mat_win.diffuse_color = (0.4, 0.4, 0.4, 1)
        mat_win_nodebsdf = mat_win.node_tree.nodes.get('Principled BSDF')
        mat_win_nodebsdf.inputs[0].default_value = (0.1, 0.1, 0.1, 1)

            #Assign material
        win.active_material = mat_glass
        win.data.materials.append(mat_win)

    # NOW ADD WINDOWS WITH ADD OBJECT TOOL
        bpy.context.view_layer.objects.active = win_bool
        bpy.ops.object.editmode_toggle()
        bpy.ops.mesh.delete(type='VERT')
        bpy.ops.wm.tool_set_by_id(name="builtin.primitive_cube_add")

        window_variables = ["WINDOW",  # CUSTOM PROPERTY :
                            win.name,  # Target
                            win_weld.name,
                            win_disp.name,
                            win_wire.name,
                            win_beve.name,
                             ]
        context.scene.bagapieValue = ""
        for var in window_variables:
            context.scene.bagapieValue = context.scene.bagapieValue + var + " "

        return {'FINISHED'}


class MoCurveArray(Operator):
    bl_idname = "wm.curvearray"
    bl_label = "Auto Array on Curve"
    bl_options = {'REGISTER', 'UNDO'}

    # PANEL INPUT
    curvearray_relative_offset: bpy.props.BoolProperty(
        name="Relative Offset",
        default=True,
    )
    rovec: bpy.props.FloatProperty(
        name="Distance",
        description="Distance between objects based on the size of the instance.",
        default=1,
        min=0,
        soft_max=1000,
    )
    con: bpy.props.BoolProperty(
        name="Constant Offset",
        default=True,
    )
    covec: bpy.props.FloatProperty(
        name="Distance",
        description="Constant distance between objects.",
        default=0,
        min=0,
        soft_max=1000,
    )
    curvearray_axis: bpy.props.EnumProperty(
        name="Dirrection",
        items=[('POS_X', "X", ""),
               ('POS_Y', "Y", ""),
               ('POS_Z', "Z", ""),
               ('NEG_X', "-X", ""),
               ('NEG_Y', "-Y", ""),
               ('NEG_Z', "-Z", ""),
               ],
        default='POS_X'
    )

    def execute(self, context):
    # PREPARE MESH (POSITION, ROTATION, SCALE)
        # FILTERING SELECTED
        selected_curve = bpy.context.selected_objects
        target = bpy.context.active_object
        selected_curve_valid = []

        for mesh in selected_curve:
            if mesh.type == 'MESH' or mesh.type == 'CURVE':
                selected_curve_valid.append(mesh)

        bpy.ops.object.select_all(action='DESELECT')
        for ob in selected_curve_valid:
            ob.select_set(True)
        if selected_curve_valid is not None:
            selected_curve_valid.remove(target)

            # PREPARE MESH
            if target.type == "CURVE" and selected_curve_valid is not None:
                bpy.ops.object.transform_apply(location=False, rotation=True, scale=True)
                bpy.ops.view3d.snap_cursor_to_active()
                bpy.ops.object.editmode_toggle()
                bpy.ops.curve.select_all(action='SELECT')
                bpy.ops.curve.radius_set(radius=1.0)
                bpy.ops.object.editmode_toggle()
                bpy.ops.view3d.snap_selected_to_cursor(use_offset=False)

            # ADD MODIFIER
                #for ob in selected_curve_valid:
                #new = bpy.data.objects[ob.name].modifiers.new
                new = bpy.data.objects[selected_curve_valid[0].name].modifiers.new
                arr = new(name='BagaArray', type='ARRAY')
                cur = new(name='BagaCurve', type='CURVE')
                arr.fit_type = 'FIT_CURVE'
                arr.curve = target
                cur.object = target
                cur.deform_axis = self.curvearray_axis

                arr.use_relative_offset = self.curvearray_relative_offset
                arr.use_constant_offset = self.con
                arr.relative_offset_displace[0] = self.rovec
                arr.constant_offset_displace[0] = self.covec

                bpy.context.view_layer.objects.active = target

                curve_variables = ["CURVE",  # CUSTOM PROPERTY :
                                  selected_curve_valid[0].name,
                                  arr.name,
                                  cur.name,
                                  ]
                context.scene.bagapieValue = ""
                for var in curve_variables:
                    context.scene.bagapieValue = context.scene.bagapieValue + var + " "  # replace by += ...

                return {'FINISHED'}
            else:
                bpy.ops.wm.call_menu(name=WarningPopup.bl_idname)
                print("Object missing in selection. Select object then Curve.")


        else:
            layout = self.layout

            layout.label(text="Wrong Selection. Select meshes then add Curve in selection.", icon='ERROR')
            bpy.ops.wm.call_menu(name=WarningPopup.bl_idname)
            print("Wrong Selection. Select meshes then add Curve in selection.")

        return {'FINISHED'}


class MoScatterPaint(Operator):
    bl_idname = "wm.scatter_paint"
    bl_label = "Scatter Paint"
    bl_options = {'REGISTER', 'UNDO'}

    # UI PANEL INPUTS

    distance_min: bpy.props.FloatProperty(
        name="Distance Min",
        default=0.5,
        min=0,
    )
    density: bpy.props.FloatProperty(
        name="Density",
        default=10,
        min=0,
    )
    scale_min: bpy.props.FloatProperty(
        name="Scale Min",
        default=1,
        min=0,
        soft_max=100,
    )
    scale_max: bpy.props.FloatProperty(
        name="Scale Max",
        default=1,
        min=0,
        soft_max=100,
    )
    random_rot: bpy.props.FloatVectorProperty(
        name="Randomize Rotation",
        default=[0, 0, 0],
    )
    align_to_normal: bpy.props.FloatProperty(
        name="Align to Normal",
        default=0,
        min=0,
        max=1,
    )
    seed: bpy.props.IntProperty(
        name="Seed",
        default=1,
        min=0
    )

    def execute(self, context):

        target = bpy.context.active_object

        if target.modifiers.get("BagaScatter") is not None:
            if target.modifiers.get("BagaScatter").show_viewport == True:
                bpy.ops.wm.warninghidescatter('INVOKE_DEFAULT') # Hide Scater modifier

        # COLLECTION
        # Create collection and check if the main "Baga Collection" does not already exist
        if bpy.data.collections.get("BagaPie_Mesh") is None:
            main_coll = bpy.data.collections.new("BagaPie_Mesh")
            bpy.context.scene.collection.children.link(main_coll)
            scatt_coll = bpy.data.collections.new("BagaPie_InstancePaint_" + target.name)
            main_coll.children.link(scatt_coll)
        # If the main "Baga Collection" already exist
        else:
            scatt_coll = bpy.data.collections.new("BagaPie_InstancePaint_" + target.name)
            main_coll = bpy.data.collections["BagaPie_Mesh"]
            main_coll.children.link(scatt_coll)

        obj = bpy.context.selected_objects
        obj.remove(target)

        instances_max_dimensions = 0
        for ob in obj:                                          # Get instance max dimensions
            if ob.dimensions.x > instances_max_dimensions:
                instances_max_dimensions = ob.dimensions.x
                if ob.dimensions.x < ob.dimensions.y:
                    instances_max_dimensions = ob.dimensions.y
            scatt_coll.objects.link(ob)                         # Add instances to instances coll

        # CREATE SCATTER MODIFIER

        #CREATE VERTEX GROUP
        scatt_vertex_grp = target.vertex_groups.new(name="BagaVertGrp")

        # ADD MODIFIER
        new = bpy.data.objects[target.name].modifiers.new
        scatt = new(name='BagaScatterPaint', type='NODES')
        scatt_nde_group = scatt.node_group
        scatt_nde_group.name = "BagaScatterPaint"

        # GET IN AND OUT NODES
        scatt_nde_inp = scatt_nde_group.nodes[0]
        scatt_nde_out = scatt_nde_group.nodes[1]

        # ADD NODES
        scatt_nde_poidist = scatt_nde_group.nodes.new('GeometryNodePointDistribute')
        scatt_nde_randsca = scatt_nde_group.nodes.new('GeometryNodeAttributeRandomize')
        scatt_nde_randrot = scatt_nde_group.nodes.new('GeometryNodeAttributeRandomize')
        scatt_nde_alitovec = scatt_nde_group.nodes.new('GeometryNodeAlignRotationToVector')
        scatt_nde_insta = scatt_nde_group.nodes.new('GeometryNodePointInstance')
        scatt_nde_join = scatt_nde_group.nodes.new('GeometryNodeJoinGeometry')
        scatt_nde_vecmat = scatt_nde_group.nodes.new('ShaderNodeVectorMath')

        # POSITION NODES
        scatt_nde_inp.location = (0, 0)  # Group input
        scatt_nde_out.location = (1400, 0)  # Group output
        scatt_nde_poidist.location = (200, 200)  # Point distribute
        scatt_nde_randsca.location = (400, 200)  # Randomise scale
        scatt_nde_randrot.location = (600, 200)  # Randomise rotation
        scatt_nde_alitovec.location = (800, 200)  # Align rotation to vector
        scatt_nde_insta.location = (1000, 200)  # Point instance
        scatt_nde_join.location = (1200, 0)  # Join
        scatt_nde_vecmat.location = (400, -80)  # Vector math

        # LINK NODES,UI & CONFIG
        new_link = scatt_nde_group.links
        # Geometry path
        new_link.new(scatt_nde_inp.outputs[0], scatt_nde_poidist.inputs[0])
        new_link.new(scatt_nde_poidist.outputs[0], scatt_nde_randsca.inputs[0])
        new_link.new(scatt_nde_randsca.outputs[0], scatt_nde_randrot.inputs[0])
        new_link.new(scatt_nde_randrot.outputs[0], scatt_nde_alitovec.inputs[0])
        new_link.new(scatt_nde_alitovec.outputs[0], scatt_nde_insta.inputs[0])
        new_link.new(scatt_nde_insta.outputs[0], scatt_nde_join.inputs[0])
        new_link.new(scatt_nde_join.outputs[0], scatt_nde_out.inputs[0])
        new_link.new(scatt_nde_inp.outputs[0], scatt_nde_join.inputs[0])

        # Config Nodes
        scatt_nde_randsca.inputs[1].default_value = "scale"
        scatt_nde_randrot.data_type = 'FLOAT_VECTOR'
        scatt_nde_randrot.inputs[1].default_value = "rotation"
        scatt_nde_alitovec.axis = 'Z'
        scatt_nde_alitovec.input_type_vector = 'ATTRIBUTE'
        scatt_nde_alitovec.inputs[3].default_value = "normal"
        scatt_nde_vecmat.operation = 'MULTIPLY'
        scatt_nde_vecmat.inputs[1].default_value[0] = (-1)
        scatt_nde_vecmat.inputs[1].default_value[1] = (-1)
        scatt_nde_vecmat.inputs[1].default_value[2] = (-1)
        scatt_nde_insta.instance_type = 'COLLECTION'
        scatt_nde_insta.use_whole_collection = False
        scatt_nde_insta.inputs[2].default_value = scatt_coll
        scatt_nde_poidist.distribute_method = 'POISSON'
        scatt_nde_poidist.inputs[3].default_value = scatt_vertex_grp.name

        # UI geometry node, add inputs
        scatt_nde_group.inputs.new(type="NodeSocketFloat", name="Distance Min")
        scatt_nde_group.inputs[1].min_value = 0
        scatt_nde_group.inputs[1].default_value = 0
        scatt_nde_group.inputs.new(type="NodeSocketFloat", name="Density")
        scatt_nde_group.inputs[2].min_value = 0
        scatt_nde_group.inputs[2].default_value = 1
        scatt_nde_group.inputs.new(type="NodeSocketFloat", name="Scale Min")
        scatt_nde_group.inputs[3].default_value = 1
        scatt_nde_group.inputs.new(type="NodeSocketFloat", name="Scale Max")
        scatt_nde_group.inputs[4].default_value = 1
        scatt_nde_group.inputs.new(type="NodeSocketVector", name="Randomize Rotation")
        scatt_nde_group.inputs[5].default_value[0] = 0
        scatt_nde_group.inputs[5].default_value[1] = 0
        scatt_nde_group.inputs[5].default_value[2] = 0
        scatt_nde_group.inputs.new(type="NodeSocketFloatFactor", name="Align to Normal")
        scatt_nde_group.inputs[6].min_value = 0
        scatt_nde_group.inputs[6].max_value = 1
        scatt_nde_group.inputs[6].default_value = 1
        scatt_nde_group.inputs.new(type="NodeSocketInt", name="Seed")
        scatt_nde_group.inputs[7].default_value = 1
        scatt_nde_group.inputs[7].min_value = 0

        # Link nodes to group input node
        new_link.new(scatt_nde_inp.outputs[1], scatt_nde_poidist.inputs[1])
        new_link.new(scatt_nde_inp.outputs[2], scatt_nde_poidist.inputs[2])
        new_link.new(scatt_nde_inp.outputs[7], scatt_nde_poidist.inputs[4])
        new_link.new(scatt_nde_inp.outputs[3], scatt_nde_randsca.inputs[4])
        new_link.new(scatt_nde_inp.outputs[4], scatt_nde_randsca.inputs[5])
        new_link.new(scatt_nde_inp.outputs[6], scatt_nde_alitovec.inputs[2])
        new_link.new(scatt_nde_inp.outputs[5], scatt_nde_vecmat.inputs[0])
        new_link.new(scatt_nde_inp.outputs[5], scatt_nde_randrot.inputs[2])
        new_link.new(scatt_nde_vecmat.outputs[0], scatt_nde_randrot.inputs[3])

        # Switch to weight paint
        bpy.ops.paint.weight_paint_toggle()

        # SCATTER MODIFIER SET VALUE
        bpy.context.object.modifiers[scatt.name]["Input_5"] = self.distance_min * instances_max_dimensions
        bpy.context.object.modifiers[scatt.name]["Input_7"] = self.density
        bpy.context.object.modifiers[scatt.name]["Input_9"] = self.scale_min
        bpy.context.object.modifiers[scatt.name]["Input_11"] = self.scale_max
        bpy.context.object.modifiers[scatt.name]["Input_13"][0] = self.random_rot[0]
        bpy.context.object.modifiers[scatt.name]["Input_13"][1] = self.random_rot[1]
        bpy.context.object.modifiers[scatt.name]["Input_13"][2] = self.random_rot[2]
        bpy.context.object.modifiers[scatt.name]["Input_15"] = self.align_to_normal
        bpy.context.object.modifiers[scatt.name]["Input_17"] = self.seed

        scatterpaint_variables = ["SCATTERPAINT",  # CUSTOM PROPERTY :
                           target.name,
                           scatt.name,
                           ]
        context.scene.bagapieValue = ""
        for var in scatterpaint_variables:
            context.scene.bagapieValue = context.scene.bagapieValue + var + " "  # replace by += ...

        return {'FINISHED'}

# _______________________________________________ INFO POPUP

# /!\ This part (still) need to be completely rewritten /!\

class WarningPopup(bpy.types.Menu):
    bl_label = "WARNING !"
    bl_idname = "OBJECT_MT_custom_menu"

    def draw(self, context):
        layout = self.layout

        layout.label(text="Wrong Selection. Select meshes then add Curve in selection.", icon='ERROR')

class WarningHideScatter(bpy.types.Operator):
    bl_idname = "wm.warninghidescatter"
    bl_label = "To preserve performance, hide Scatter Modifier?"

    def execute(self, context):
        target = bpy.context.active_object
        if target.modifiers.get("BagaScatter") is not None:
            target.modifiers.get("BagaScatter").show_viewport = False
        return {'FINISHED'}

    def invoke(self, context, event):
        wm = context.window_manager
        return wm.invoke_props_dialog(self)

def menu_draw(self, context):
    self.layout.operator("wm.warninghidescatter")

def draw_item(self, context):
    layout = self.layout
    layout.menu(WarningPopup.bl_idname)

# _______________________________________________ REGISTER / UNREGISTER

addon_keymaps = []
classes = [
    BAGAPIE_MT_PIE_template, #UI
    BAGAPANEL_PT_modifier_panel,
    SwitchMode,
    InvertPaint,
    CleanWPaint,
    MoArray, #Operator
    MoBoolean,
    MoWall,
    MoScatter,
    MoDisplace,
    MoWindow,
    MoCurveArray,
    MoScatterPaint,
    WarningPopup, #Warning
    WarningHideScatter,
    ]

def register():
    for cls in classes:
        bpy.utils.register_class(cls)
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    if kc:
        km = kc.keymaps.new(name='3D View', space_type='VIEW_3D')
        kmi = km.keymap_items.new("wm.call_menu_pie", type='J', value='PRESS')
        kmi.properties.name = "mesh.bagapie"
        addon_keymaps.append((km,kmi))

    bpy.types.Scene.bagapieValue = bpy.props.StringProperty(
        name="My List",
        default="none"
    )

    bpy.types.INFO_HT_header.append(draw_item) #ERROR
    bpy.types.TEXT_MT_text.append(menu_draw)

def unregister():
    for km,kmi in addon_keymaps:
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    for cls in classes:
        bpy.utils.unregister_class(cls)

    bpy.types.INFO_HT_header.remove(draw_item) #ERROR

if __name__ == "__main__":
    register()
